% exa_OBOMP using the OBOMP function
%
%  It separates the component fv in V  from f=fv+fw; with fw in WC (uses OBOMP)

     sp=[0 1]; L=1000; x=linspace(sp(1),sp(2),L);
     m=230; dnn=200; ns=15; npu=200;
%============================================================
%    generates V and WC 
%============================================================
     n=1:L; k=1:m; V=cos(pi*(2*n-1)'*((k-1)/(2*L)));
     for i=1:dnn; pul(i,:)=exp(-75000*(x-i*0.005).^2);end
     WC=pul';
%============================================================
%    generates the signal components fv and fw and ff=fv+fw;
%============================================================
     rand('state',5);ip=randperm(dnn);
     rand('state',7);amp=(0.5-rand(dnn,1));g=0;
     for jj=1:npu; g=g+5*amp(jj)*pul(ip(jj),:);end
     rand('state',3);b=rand(ns,1);
     rand('state',9);ii=randperm(size(V,2)); VS=V(:,ii(1:ns));
     fv=(VS*b)'; fw=10*g; f=fv+fw;
%==============================================================
%    small errors simulation (0.1% error to each data point)
%==============================================================
    expn=9; pers=0.001;
    L=size(f);
    randn('state',expn);er=randn(L);
    fo=f+er*pers.*abs(f);
    fac=1;%tunes the tolerance for the error norm;
    err=fac*pers.*abs(f);
%========================================================================
[fve,Vnew,Di,beta,c,U,Q]=OBOMP(fo,V,WC,err);
figure(1)
plot(x,fo) %plot of the composed signal
figure(2)
plot(x,fve,x,fv); %plot of estimation of the oblique projection (fve) and fv 

